// mmulti.h

#ifndef __mmulti_h__
#define __mmulti_h__

#define MAXPLAYERS 16

#define CMD_SEND               1
#define CMD_GET                2
#define CMD_SENDTOALL          3
#define CMD_SENDTOALLOTHERS    4
#define CMD_SCORE              5

#define	MAXCOMBUFFERSIZE 2048
#define MAXPACKETSIZE 2048
typedef struct
{
	short command;               // see CMD_* constants above
	short other;                 // dest for send, set by get (-1 = no packet)
	short numbytes;
	char buffer[MAXPACKETSIZE];
} gcomtype;

// in mmulti.c
extern short myconnectindex, numplayers;
extern gcomtype gcom;

// the communication module provides these functions when linked
void callcommit(void);			// used only by mmulti.h
int setupmultiplayergame(void);		// call before main game startup like commit would have
int fillmultiplayergame(void);		// used to poll game joining status if hosting
void endmultiplayergame(void);		// call at game end like commit would have

// mmulti.c provides these to the world
void initmultiplayers(char damultioption, char dacomrateoption, char dapriority);
void setpackettimeout(long datimeoutcount, long daresendagaincount);
void uninitmultiplayers(void);
void sendlogon(void);
void sendlogoff(void);
long getoutputcirclesize(void);
void setsocket(short newsocket);
void sendpacket(long other, char *bufptr, long messleng);
short getpacket (short *other, char *bufptr);
void flushpackets(void);
void genericmultifunction(long other, char *bufptr, long messleng, long command);

#endif	// __mmulti_h__

